import { ValidationRuleContract } from "../contracts";
/**
 * The field under validation must be yes, on, 1, or true.
 * This is useful for validating "Terms of Service" acceptance.
 * @param {Array<string>} args seeds
 */
/**
 * Usage Example
 *
 * ```js
 *  async (req,res) => {
 *    const v = new niv.Validator(req.body, { tandc: 'accepted' })
 *    const passed = await v.validate();
 *    console.log(passed) // output: true
 *  }
 * ```
 */
export declare function accepted(args?: Array<string>): ValidationRuleContract;
export declare function acceptedIf(args: Array<string>, acceptedValues?: Array<string>): ValidationRuleContract;
